/* INIArc 0.2/REXX (Oct 04 1998) - Small archiver-like .INI manager
 * by Anton Dushko (2:5030/611.9)
 * This stuff is free. Comments & suggestions are welcome.
 */

/* Credits */
Say "INIArc 0.2/REXX (Oct 04 1998) - Small archiver-like .INI manager" || "0D0A"x ||,
    "by Anton Dushko (2:5030/611.9)" || "0D0A"x

/* Startup */
Call RxFuncAdd "SysLoadFuncs", "RexxUtil", "SysLoadFuncs"
Call SysLoadFuncs

SysINIFile = "USER"
SysINIFileName = "OS2.INI"

/* Parse command line */
Parse Arg Command INIFile Application"\"Key
If INIFile = "" Then
Do
  Call PrintHelp 
  Exit 1
End  
Command = Translate(Command)
Application = Strip(Application)
Key = Strip(Key)

/* Select command */
Select

  /* Extract */
  When Left(Command, 1) = "X" Then
  Select

    /* All applications */
    When (Application = "") & (Key = "") Then
    Do
      Say "Extracting all applications from " || INIFile || " to " || SysINIFileName || ":" || "0D0A"x
      KeysOK = 0
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        If SysIni(INIFile, Apps.J, "All:", "Keys") <> "ERROR:" Then
        Do
          Say Left(Apps.J, 65) || " " || Keys.0 || " key(s)"
          AppsOK = AppsOK + 1

          Do I = 1 to Keys.0
            Call CharOut , Left(Apps.J || "\" || Keys.I, 65) || " "

            Val = SysIni(INIFile, Apps.J, Keys.I)
            If Val = "ERROR:" Then
              Say "Error"
            Else
              If SysIni(SysINIFile, Apps.J, Keys.I, Val) = "ERROR:" Then
                Say "Error"
              Else
              Do
                KeysOK = KeysOK + 1
                Say "OK"
              End
          End I

          /* Move */
          If Command = "XM" Then
          Do 
            Call CharOut , "Deleting keys..." || "D"x

            Do I = 1 to Keys.0
              If SysIni(INIFile, Apps.J, Keys.I, "DELETE:") = "ERROR:" Then
                Say "Error deleting " || Apps.J || "\" || Keys.I
            End I
          End
        End
        Else
          Say Left(Apps.J, 65) || " " || "Error"
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s) with " || KeysOK || " key(s) extracted"
    End

    /* One application */
    When (Application <> "") & (Key = "") Then
    Do
      Say "Extracting applicaction """ || Application || """ from " || INIFile || " to " || SysINIFileName || ":" || "0D0A"x
      KeysOK = 0

      If SysIni(INIFile, Application, "All:", "Keys") <> "ERROR:" Then
      Do
        Say Left(Application, 65) || " " || Keys.0 || " key(s)"

        Do I = 1 to Keys.0
          Call CharOut , Left(Application || "\" || Keys.I, 65) || " "

          Val = SysIni(INIFile, Application, Keys.I)
          If Val = "ERROR:" Then
            Say "Error"
          Else
            If SysIni(SysINIFile, Application, Keys.I, Val) = "ERROR:" Then
              Say "Error"
            Else
            Do
              KeysOK = KeysOK + 1
              Say "OK"
            End
        End I

        /* Move */
        If Command = "XM" Then
        Do 
          Call CharOut , "Deleting keys..." || "D"x

          Do I = 1 to Keys.0
            If SysIni(INIFile, Application, Keys.I, "DELETE:") = "ERROR:" Then
               Say "Error deleting " || Application || "\" || Keys.I
          End I
        End
      End
      Else
        Say "Error: Application or .INI file not found"

      Say "  " || KeysOK || " key(s) extracted"
    End

    /* One key */
    When (Application <> "") & (Key <> "") Then
    Do
      Say "Extracting single key from " || INIFile || " to " || SysINIFileName || ":" || "0D0A"x

      Call CharOut , Left(Application || "\" || Key, 65) || " "

      Val = SysIni(INIFile, Application, Key)
      If Val = "ERROR:" Then
        Say "Error"
      Else
        If SysIni(SysINIFile, Application, Key, Val) = "ERROR:" Then
          Say "Error"
        Else
          Say "OK"

      /* Move */
      If Command = "XM" Then
        If SysIni(INIFile, Application, Key, "DELETE:") = "ERROR:" Then
           Say "Error deleting " || Application || "\" || Key
    End
    /* Bad command line */
    Otherwise
      Say "Invalid combination of command line parameters"
  End

  /* Add */
  When Left(Command, 1) = "A" Then
  Select

    /* One application */
    When (Application <> "") & (Key = "") Then
    Do
      Say "Adding application """ || Application || """ from " || SysINIFileName || " to " || INIFile || ":" || "0D0A"x
      KeysOK = 0

      If SysIni(SysINIFile, Application, "All:", "Keys") <> "ERROR:" Then
      Do
        Say Left(Application, 65) || " " || Keys.0 || " key(s)"

        Do I = 1 to Keys.0
          Call CharOut , Left(Application || "\" || Keys.I, 65) || " "

          Val = SysIni(SysINIFile, Application, Keys.I)
          If Val = "ERROR:" Then
            Say "Error"
          Else
            If SysIni(INIFile, Application, Keys.I, Val) = "ERROR:" Then
              Say "Error"
            Else
            Do
              KeysOK = KeysOK + 1
              Say "OK"
            End
        End I

        /* Move */
        If Command = "AM" Then
        Do 
          Call CharOut , "Deleting keys..." || "D"x

          Do I = 1 to Keys.0
            If SysIni(SysINIFile, Application, Keys.I, "DELETE:") = "ERROR:" Then
               Say "Error deleting " || Application || "\" || Keys.I
          End I
        End
      End
      Else
        Say "Error: Application not found"

      Say "  " || KeysOK || " key(s) added"
    End

    /* One key */
    When (Application <> "") & (Key <> "") Then
    Do
      Say "Adding single key from " || SysINIFileName || " to " || INIFile || ":" || "0D0A"x

      Call CharOut , Left(Application || "\" || Key, 65) || " "

      Val = SysIni(SysINIFile, Application, Key)
      If Val = "ERROR:" Then
        Say "Error"
      Else
        If SysIni(INIFile, Application, Key, Val) = "ERROR:" Then
          Say "Error"
        Else
          Say "OK"

      /* Move */
      If Command = "AM" Then
        If SysIni(SysINIFile, Application, Key, "DELETE:") = "ERROR:" Then
           Say "Error deleting " || Application || "\" || Key
    End

    /* Bad command line */
    Otherwise
      Say "Invalid combination of command line parameters"
  End

  /* Delete */
  When Command = "D" Then
  Select

    /* All applications */
    When (Application = "") & (Key = "") Then
    Do
      Say "Deleting all applications from " || INIFile || ":" || "0D0A"x
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        Call CharOut , Left(Apps.J, 65) || " "

        If SysIni(INIFile, Apps.J, "DELETE:") <> "ERROR:" Then
        Do
          Say "OK"
          AppsOK = AppsOK + 1
        End
        Else
          Say "Error"
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s) deleted"
    End

    /* One application */
    When (Application <> "") & (Key = "") Then
    Do
      Say "Deleting single application from " || INIFile || ":" || "0D0A"x

      Call CharOut , Left(Application, 65) || " "

      If SysIni(INIFile, Application, "DELETE:") <> "ERROR:" Then
        Say "OK"
      Else
        Say "Error"
    End

    /* One key */
    When (Application <> "") & (Key <> "") Then
    Do
      Say "Deleting single key from " || INIFile || ":" || "0D0A"x

      Call CharOut , Left(Application || "\" || Key, 65) || " "

      If SysIni(INIFile, Application, Key, "DELETE:") = "ERROR:" Then
        Say "Error"
      Else
        Say "OK"
    End

    /* Bad command line */
    Otherwise
      Say "Invalid combination of command line parameters"
  End

  /* View */
  When Command = "V" Then
  Select

    /* All applications */
    When (Application = "") & (Key = "") Then
    Do
      Say "Dump of all keys from " || INIFile || ":" || "0D0A"x
      KeysOK = 0
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        If SysIni(INIFile, Apps.J, "All:", "Keys") <> "ERROR:" Then
        Do
          Say Left(Apps.J, 65) || " " || Keys.0 || " key(s)"
          AppsOK = AppsOK + 1

          Do I = 1 to Keys.0
            Call CharOut , Left(Apps.J || "\" || Keys.I, 65) || " "

            Val = SysIni(INIFile, Apps.J, Keys.I)
            If Val = "ERROR:" Then
              Say "Error"
            Else
            Do
              KeysOK = KeysOK + 1
              Say Length(Val) || " byte(s)"
              Call DumpString Val
              Say
            End
          End I
        End
        Else
          Say Left(Apps.J, 65) || " " || "Error"
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s) with " || KeysOK || " key(s)"
    End

    /* One application */
    When (Application <> "") & (Key = "") Then
    Do
      Say "Dump of keys in application """ || Application || """ from " || INIFile || ":" || "0D0A"x
      KeysOK = 0

      If SysIni(INIFile, Application, "All:", "Keys") <> "ERROR:" Then
      Do
        Say Left(Application, 65) || " " || Keys.0 || " key(s)"

        Do I = 1 to Keys.0
          Call CharOut , Left(Application || "\" || Keys.I, 65) || " "

          Val = SysIni(INIFile, Application, Keys.I)
          If Val = "ERROR:" Then
            Say "Error"
          Else
          Do
            KeysOK = KeysOK + 1
            Say Length(Val) || " byte(s)"
            Call DumpString Val
            Say
          End
        End I
      End
      Else
        Say "Error: Application or .INI file not found"

      Say "  " || KeysOK || " key(s)"
    End

    /* One key */
    When (Application <> "") & (Key <> "") Then
    Do
      Say "Dump of single key from " || INIFile || ":" || "0D0A"x

      Call CharOut , Left(Application || "\" || Key, 65) || " "

      Val = SysIni(INIFile, Application, Key)
      If Val = "ERROR:" Then
        Say "Error"
      Else
      Do
        Say Length(Val) || " byte(s)"
        Call DumpString Val
      End
    End

    /* Bad command line */
    Otherwise
      Say "Invalid combination of command line parameters"
  End

  /* List */
  When Left(Command, 1) = "L" Then
  Select

    /* All keys, normal */
    When (Application = "") & (Command = "L") Then
    Do
      Say "List of keys in " || INIFile || ":" || "0D0A"x
      KeysOK = 0
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        If SysIni(INIFile, Apps.J, "All:", "Keys") <> "ERROR:" Then
        Do
          Say Left(Apps.J, 65) || " " || Keys.0 || " key(s)"
          AppsOK = AppsOK + 1

          Do I = 1 to Keys.0
            Call CharOut , Left(Apps.J || "\" || Keys.I, 65) || " "

            Val = SysIni(INIFile, Apps.J, Keys.I)
            If Val = "ERROR:" Then
              Say "Error"
            Else
            Do
              KeysOK = KeysOK + 1
              Say Length(Val) || " byte(s)"
            End
          End I
        End
        Else
          Say Left(Apps.J, 65) || " " || "Error"
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s) with " || KeysOK || " key(s)"
    End

    /* All keys, fast */
    When (Application = "") & (Command = "LF") Then
    Do
      Say "List of keys in " || INIFile || ":" || "0D0A"x
      KeysOK = 0
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        If SysIni(INIFile, Apps.J, "All:", "Keys") <> "ERROR:" Then
        Do
          Say Left(Apps.J, 65) || " " || Keys.0 || " key(s)"
          AppsOK = AppsOK + 1

          Do I = 1 to Keys.0
            Say Left(Apps.J || "\" || Keys.I, 78)
            KeysOK = KeysOK + 1
          End I
        End
        Else
          Say Left(Apps.J, 65) || " " || "Error"
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s) with " || KeysOK || " key(s)"
    End

    /* All applications, normal */
    When (Application = "") & (Command = "LA") Then
    Do
      Say "List of applications in " || INIFile || ":" || "0D0A"x
      KeysOK = 0
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        If SysIni(INIFile, Apps.J, "All:", "Keys") <> "ERROR:" Then
        Do
          Say Left(Apps.J, 65) || " " || Keys.0 || " key(s)"
          AppsOK = AppsOK + 1
          KeysOK = KeysOK + Keys.0
        End
        Else
          Say Left(Apps.J, 65) || " " || "Error"
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s) with " || KeysOK || " key(s)"
    End

    /* All applications, fast */
    When (Application = "") & (Command = "LAF") Then
    Do
      Say "List of applications in " || INIFile || ":" || "0D0A"x
      AppsOK = 0

      If SysIni(INIFile, "All:", "Apps") <> "ERROR:" Then
      Do J = 1 To Apps.0
        Say Left(Apps.J, 78)
        AppsOK = AppsOK + 1
      End J
      Else
        Say "Error: .INI file not found"

      Say "  " || AppsOK || " application(s)"
    End

    /* One application, normal */
    When (Application <> "") & (Command = "L") Then
    Do
      Say "List of keys in application """ || Application || """ from " || INIFile || ":" || "0D0A"x
      KeysOK = 0

      If SysIni(INIFile, Application, "All:", "Keys") <> "ERROR:" Then
      Do
        Say Left(Application, 65) || " " || Keys.0 || " key(s)"

        Do I = 1 to Keys.0
          Call CharOut , Left(Application || "\" || Keys.I, 65) || " "

          Val = SysIni(INIFile, Application, Keys.I)
          If Val = "ERROR:" Then
            Say "Error"
          Else
          Do
            KeysOK = KeysOK + 1
            Say Length(Val) || " byte(s)"
          End
        End I
      End
      Else
        Say "Error: Application or .INI file not found"

      Say "  " || KeysOK || " key(s)"
    End

    /* One application, fast */
    When (Application <> "") & (Command = "LF") Then
    Do
      Say "List of keys in application """ || Application || """ from " || INIFile || ":" || "0D0A"x
      KeysOK = 0

      If SysIni(INIFile, Application, "All:", "Keys") <> "ERROR:" Then
      Do
        Say Left(Application, 65) || " " || Keys.0 || " key(s)"

        Do I = 1 to Keys.0
          Say Left(Application || "\" || Keys.I, 78)
        End I
      End
      Else
        Say "Error: Application or .INI file not found"

      Say "  " || Keys.0 || " key(s)"
    End
 
    /* Bad command line */
    Otherwise
      Say "Invalid combination of command line parameters"
  End

  /* Help */
  Otherwise
    Call PrintHelp
    Exit 1
End

/* All OK*/
Exit 0

/* Supplemental procedures */

/* Some help */
PrintHelp: Procedure
  Say "Usage: INIArc <Command> <.INI file> [<Application>[\<Key>]]" || "0D0A"x ||,
      "0D0A"x ||,
      "  Add application          : A[M] <Application>" || "0D0A"x ||,
      "  Add single key           : A[M] <Application>\<Key>" || "0D0A"x ||,
      "  Extract all applications : X[M]" || "0D0A"x ||,
      "  Extract application      : X[M] <Application>" || "0D0A"x ||,
      "  Extract single key       : X[M] <Application>\<Key>" || "0D0A"x ||,
      "  Delete all applications  : D" || "0D0A"x ||,
      "  Delete application       : D <Application>" || "0D0A"x ||,
      "  Delete single key        : D <Application>\<Key>" || "0D0A"x ||,
      "  List all keys            : L[F]" || "0D0A"x ||,
      "  List all applications    : LA[F]" || "0D0A"x ||,
      "  List keys of application : L[F] <Application>" || "0D0A"x ||,
      "  View all keys            : V" || "0D0A"x ||,
      "  View keys of application : V <Application>" || "0D0A"x ||,
      "  View single key          : V <Application>\<Key>" || "0D0A"x ||,
      "0D0A"x ||,
      "  [M] - Move, delete source after operation." || "0D0A"x ||,
      "  [F] - Fast list without extra info like number of" || "0D0A"x ||,
      "     keys in application & length of key data"
Return

/* Print hexdump of string */
DumpString: Procedure
  Arg Val

  Do Pos = 1 To Length(Val) By 16
    If Pos + 16 < Length(Val) Then
    Do
      Say "  " || Right(D2X(Pos - 1), 4, 0) || ": " || Translate("01 23 45 67 89 AB CD EF  GH IJ KL MN OP QR ST UV", C2X(SubStr(Val, Pos, 16)), "0123456789ABCDEFGHIJKLMNOPQRSTUV") || "  " || SubStr(Translate(Val, Copies(".", 32), XRange("00"x, "1F"x)), Pos, 16)
    End
    Else
      Say "  " || Right(D2X(Pos - 1), 4, 0) || ": " || Translate("01 23 45 67 89 AB CD EF  GH IJ KL MN OP QR ST UV", C2X(SubStr(Val, Pos)), "0123456789ABCDEFGHIJKLMNOPQRSTUV") || "  " || SubStr(Translate(Val, Copies(".", 32), XRange("00"x, "1F"x)), Pos, 16)
  End Pos
Return

/* End of INIArc.CMD */
